#ifndef _INTERNAL_H
#define _INTERNAL_H

#ifdef FIXED_MATH
#  define FIXED_TYPE int
#  define FIXED(x) ((int)((x) * 256))
#  define DIV(x, y) ((((x) + ((y) >> 1)) << 8) / (y))
#  define MOD(x, y) ((x) % (y))
#  define FIXED_TO_INT(x) (((x) + 128) >> 8)
#else
#  define FIXED_TYPE double
#  define FIXED(x) x
#  define DIV(x, y) ((x) / (y))
#  define MOD(x, y) fmod (x, y)
#  define FIXED_TO_INT(x) (x)
#endif

#define INLINE static __inline__

#define TYPE_SQUARE 0

#if 0 /* undefined at the moment */
#  define TYPE_SINUS 1
#  define TYPE_PSGSQR 2
#endif 

#define MFP_FREQUENCY 2457600
#define PSG_FREQUENCY 2000000
#define QUALITY (1<<14)
#define SAMPLE_TYPE TYPE_SQUARE
#define SAMPLE_MAX 0x7fff
#define SAMPLE_MIN 0x8000
#define NOISE_MAX 0xffff

struct frame {
  int wave_period[3];
  int rfreq[3];
  int rvol[3];
  int tone[3];
  int noise[3];
  int noisecnt;
  int noiseval;
  int noiselev;
  int env[3];
  int env_mode;
  int env_period;
  double env_freq;
  int sample_freq;
};

double env_wave(double, int);

#endif /* _INTERNAL_H */
